/* $Id: crc32.h 34 2006-04-16 23:33:41Z selinger $ */

#ifndef CRC32_H
#define CRC32_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#ifdef HAVE_STDINT_H
# include <stdint.h>
#endif

#include "hash.h"

struct crc32_state_s {
  uint32_t reg;
};
typedef struct crc32_state_s crc32_state_t;

void crc32_init(crc32_state_t *s);
void crc32_byte(crc32_state_t *s, int x);
void crc32_bytes(crc32_state_t *s, unsigned char *p, int n);
void crc32_finish(crc32_state_t *s);
void crc32_finish_with_bits(crc32_state_t *s, int n, unsigned char buf);
void crc32_gethash(crc32_state_t *s, unsigned char *p);

hash_object_t *crc32_new(void);

#endif /* CRC32_H */

