/* $Id: sha256.h,v 1.2 2000/12/16 04:01:16 selinger Exp $ */

#ifndef SHA256_H
#define SHA256_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#ifdef HAVE_STDINT_H
# include <stdint.h>
#endif

#include "hash.h"

struct sha256_state_s {
  uint32_t count_hi, count_lo;  /* how many bits processed total */
  uint32_t j;                   /* how many bytes processed in current block */
  uint32_t W[16];               /* message schedule, first byte *(char *)W */
  uint32_t H[8];                /* hash value, first byte H[0]>>24 */
};
typedef struct sha256_state_s sha256_state_t;

void sha256_init(sha256_state_t *s);
void sha256_byte(sha256_state_t *s, int x);
void sha256_bytes(sha256_state_t *s, unsigned char *p, int n);
void sha256_finish(sha256_state_t *s);
void sha256_finish_with_bits(sha256_state_t *s, int n, unsigned char buf);
void sha256_gethash(sha256_state_t *s, unsigned char *p);

hash_object_t *sha256_new(void);

#endif /* SHA256_H */

